
Redmine - Feature #3848

Permission to log time for another user

2009-09-11 15:59 - Cedric VINCENT

Status: Closed Start date: 2009-09-11

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Time tracking Estimated time: 0.00 hour

Target version: 4.1.0   

Resolution: Fixed   

Description

This patch allows the current user to record the time spent by another one, as you can see in timelog1.png and timelog2.png I wrote

this patch because my co-workers are too lazy busy to update their issues ;)

I never programmed in Ruby before this patch, so feel free to rewrite it at your convenience. Maybe an exception should be thrown in

the controllers if the current user tries to edit a time entry he is not allowed to, even if it is already checked in the views.

Related issues:

Related to Redmine - Feature #8505: Log Time for Multiple Users New 2011-06-02

Related to Redmine - Patch #32196: Allow import time entries for other users Closed

Related to Redmine - Defect #32774: Creating time tracking entry for other us... Closed

Related to Redmine - Defect #32959: Fix selected user on log time edit page w... Closed

Related to Redmine - Defect #32973: Editing a time entry for a locked user ch... Closed

Related to Redmine - Feature #3800: Editing time entries should show the pers... Closed 2009-09-01

Has duplicate Redmine - Feature #10753: Abiliy to log time spent for other user Closed

Has duplicate Redmine - Feature #27328: edit the time of the user Closed

Has duplicate Redmine - Feature #7239: Allow some users to add / edit time en... Closed 2011-01-06

Has duplicate Redmine - Feature #9276: Log Time on an issue assigned to other Closed 2011-09-19

Has duplicate Redmine - Feature #6486: Log time for other users Closed 2010-09-25

Associated revisions

Revision 17755 - 2018-12-16 17:28 - Jean-Philippe Lang

Adds a permission to log time for another user (#3848).

Patch by Marius BALTEANU.

Revision 17756 - 2018-12-16 17:31 - Jean-Philippe Lang

Fix locale string name (#3848).

Revision 17758 - 2018-12-16 17:43 - Jean-Philippe Lang

Test failure.

Revision 17760 - 2018-12-16 18:23 - Jean-Philippe Lang

Don't hardcode expected text (#3848).

Revision 17762 - 2018-12-16 20:03 - Jean-Philippe Lang

Update locales (#3848).

Revision 17834 - 2019-01-20 08:41 - Jean-Philippe Lang

Update en-GB locale (#3848).

History

#1 - 2009-09-11 16:02 - Cedric VINCENT

Patch to apply against redmine-0.8.4
#2 - 2009-09-12 06:25 - Eric Davis

- Category set to Time tracking

Thank you, that's a good feature.  We'll need to update the patch to apply to trunk.  I'm not sure if the edit time entries permission should be used or if

a new one should be created.

#3 - 2009-09-12 13:34 - Jean-Philippe Lang

I think a new permission would be required if we add this feature.

#4 - 2009-09-21 16:48 - Cedric VINCENT

- File 0002-Access-params-time_entry-only-if-editing-a-time-entr.patch added

- File 0003-Allow-to-change-the-owner-a-protected-attribute-of-a.patch added

Oops! There are two bugs in the previous patch, here come the corresponding fixes:

1. Access params[:time_entry] only if editing a time entry. It fixes the error "ActiveRecord::RecordNotFound".

2. Allow to change the "owner" of a time entry. Previously, the "owner" was not changed because it is a protected attribute.

Cheers,

Cedric.

#5 - 2010-03-14 06:19 - Oleg Volkov

You can update the patch to version 0.9.3?

#6 - 2010-03-14 07:57 - Oleg Volkov

This patch is not entirely correct, since there is no information who (instead of the user) has made him the information. In addition, there is a need to

create new questions and make comments from another user. Both questions are needed when the user is not possible to do it yourself, and he

asked the operator to do so by phone.

#7 - 2010-03-14 09:11 - Oleg Volkov

- File Allow-the-current-user-to-record-the-time-spent-0.9.3.patch added

#8 - 2010-03-14 11:44 - Oleg Volkov

- File time-spent-by-another-user-v.0.1.path added

This path is changed:

1. Allow change user only entry/edit "Spent time" (http://www.redmine.org/attachments/2520/timelog1.png) and disabled from Issue Update (

http://www.redmine.org/attachments/2521/timelog2.png).

2. Select only users with permission to add record time. (Excluded admin!)

TODO: Logged real user name.

#9 - 2010-03-18 12:04 - Oleg Volkov

- File time-spent-by-another-user-v.0.2.patch added

I created a new version of the patch.

The patch is shorter.

#10 - 2011-01-05 16:57 - Arnaud Lesauvage

I'm very interested in this patch. Is the patch submitted by Oleg still working ?

We are running redmine against trunk r4359.

I still think this is a very useful feature. In our company, we have projects where the workers do not encode their spent times themselves.

Eric and Jean-Philippe both have shown interest in this so I am hopeful in seeing this integrated in trunk ?

#11 - 2011-03-21 08:45 - Jack T

- File log-time-for-another-user.diff added

Updated Oleg's patch to work on Redmine 1.1.0.

I'm new to Redmine, and one of the updates I made to Oleg's patch was in app/controllers/timelog_controller.rb, I made changes to both def new and

def create sections instead of @def edit.
#12 - 2011-08-05 05:57 - Lars Dornheim

- File patch-3848_log-time-for-others-users-ld.diff added

The last patch did not work for my Redmine 1.1.0.stable.4761, so I adapted it a little bit to work with my Redmine. Furthermore editing of the user field

of existing time logs now works for me, too.

#13 - 2012-11-29 11:17 - Pavel Potcheptsov

Is there any plan to include this in current?

#14 - 2013-01-18 16:44 - Pavel Potcheptsov

this worked for 1.3.3

but unfortunately last patch doesn't work with current 2.x.x

any suggestions?

#15 - 2013-03-13 18:37 - Bishma Stornelli Ortega

- File log-time-for-other-users.diff added

I update the patch to work with version 2.2.1. I haven't tested in any other version.

Some changes were added. In a nutshell, this patch does:

Allow users with permission :edit_time_entries to log time in a project for another user assigned to that project and with permission to log time.

Since an admin does not need to be assigned to a project to log time in it, he/she will be added to the select list of users as "<< me >>"

The label << me >> will appear in the select list if the available users include the current user (or if current user is admin as mentioned before).

These log can be done either through /projects/identifier/time_entries/new or when updating an issue. Maybe I'll add later the option to update

through /time_entries/new but it will require a little adittional work.

Let me know if you find any bug.

#16 - 2013-03-13 20:01 - Toshi MARUYAMA

- Tracker changed from Patch to Feature

#17 - 2013-03-13 21:02 - Daniel Felix

Maybe this could be a candidate for 2.4?

#18 - 2013-03-26 12:19 - Cassiano Monteiro

Agreed. This is definitely something I need (my co-workers are very lazy on logging their times).

#19 - 2013-07-08 23:18 - Gary Watson

- File log-time-for-other-users.diff added

A slightly updated diff that works with redmine 2.3.1   There was a small modification I had to make by hand to get the patch to apply otherwise it's the

same as the one produced by Bishma Stornelli Ortega that worked with 2.2.1

#20 - 2013-11-15 09:18 - Maximilian Schwerin

The last patch requires ruby >= 1.9.2.

+1 for including this in asap

#21 - 2014-02-18 14:56 - Paul Freund

- File log-time-for-other-users.diff added

The patch from Gary Watson also works with version 2.4.2 if you remove the diff for issue.rb. I've attatched an updated patch. All use cases we tested

worked but I can't guarantee it works in all.

#22 - 2014-06-05 09:21 - Pavel Potcheptsov

Paul Freund wrote:

The patch from Gary Watson also works with version 2.4.2 if you remove the diff for issue.rb. I've attatched an updated patch. All use cases we

tested worked but I can't guarantee it works in all.
 is there any plan to include this functionality in trunk?

#23 - 2014-10-30 20:59 - Alex Dergachev

I just threw together a hacky plugin that seeks to achieve the same thing

It doesn't check any permissions and probably has other bugs, but it works for us on redmine 2.6 without hacking core:

https://github.com/evolvingweb/redmine_timesheet_log_user

#24 - 2015-01-29 23:08 - Patrik Halfar

- File redmine_foreign_timelog.patch added

Hi all,

for latest version 2.6.1 I'm using following patch, is has origin in patch from this feature request, but include separete permisson, so it is possible

permit this functionality for some roles only.

Intersting should be add functionality requested by #8505.

#25 - 2015-02-17 17:54 - Josh Ovett

We tested Patrick Halfars patch, Redmine_foreign_timelog.patch and it breaks redmine 2.6.1.

#26 - 2015-04-09 09:43 - Henry Auffahrt

+1 is there a plugin for that?

Our Admin only want to implement plugins and no patch files. Thanks a Lot!

#27 - 2015-06-12 10:17 - Pavel Potcheptsov

Unfortunately this path doesn't work in redmine 3.x.

If you select another person you want to log time for, you'll get time entries logged by yourself and not by that person.

#28 - 2015-08-11 09:55 - Alexander Ryabinovskiy

We use this plugin http://www.redmine.org/plugins/redmine_work_time with Redmine 3.1.0. It allows to add / edit work time of another users. But it is

not very simple, please add this functionality to Redmine core!

#29 - 2016-01-25 07:49 - Александр Скворцов

How select collection: assigned and current user only?

#30 - 2016-07-29 13:26 - Andor Tóth

- File redmine_3_2_log_time_for_others.patch added

I have updated Patrik's patch for 3.2.0.stable.

#31 - 2017-11-08 18:08 - Toshi MARUYAMA

- Has duplicate Feature #27328: edit the time of the user added

#32 - 2018-02-12 10:46 - Andrei Melis

- File redmine_3_4_log_time_for_others.patch added

Edited the patch above for 3.4 (tested on 3.4.2)

#33 - 2018-03-31 08:33 - Grant Ferley

My Synology docker Redmine recently went to 3.3.6-1 so instead of manually patching I just put it in a plugin.  I'll be adding my own custom stuff, but

for now the master version is just a plugin for Patrik's 3.2 patch. YMMV, and it's my first attempt at ruby and Redmine plugins.

https://github.com/gferley/redmine_ferplugin

#34 - 2018-04-02 15:16 - Hans Kaiser

Grant Ferley wrote:

My Synology docker Redmine recently went to 3.3.6-1 so instead of manually patching I just put it in a plugin.  I'll be adding my own custom stuff,

but for now the master version is just a plugin for Patrik's 3.2 patch. YMMV, and it's my first attempt at ruby and Redmine plugins.

https://github.com/gferley/redmine_ferplugin
 great! do you know if your plugins supports also redmine 3.2.1. If so I can be your alpha tester...

By the way, the issue is already 8 years old. Is there any plan to integrate this patch into latest 3.x branch or maybe even into 4.0 branch?

#35 - 2018-05-05 23:23 - Marius BĂLTEANU

- File new_log_time.png added

- File filter_and_columns.png added

- File permissions.png added

- File 0001-Allow-the-current-user-to-log-time-for-other-users.patch added

I made a new patch for this feature (inspired from the existing ones) which is more complete from my point of view.

The patch:

- adds a new column ('author_id') to the time entries table where the user who logs the time spent is saved. For the existing entries, author_id will be

filled with the user_id during the migration. I found this change a must for this feature.

- makes this new column available in the columns list and filters (from Spent time tab)

- renames the permission to "Add time logs for other users"

- adds tests

- adds the user field only in the new log time page. I don't find it necessary to add the select field also to the time log section from the issue edit page.

Some screenshots attached.

This feature is long requested and it has multiple duplicate issues.

#36 - 2018-05-05 23:30 - Marius BĂLTEANU

- Related to deleted (Feature #7239: Allow some users to add / edit time entries on behalf of other users)

#37 - 2018-05-05 23:30 - Marius BĂLTEANU

- Has duplicate Feature #7239: Allow some users to add / edit time entries on behalf of other users added

#38 - 2018-05-05 23:31 - Marius BĂLTEANU

- Related to deleted (Feature #9276: Log Time on an issue assigned to other)

#39 - 2018-05-05 23:31 - Marius BĂLTEANU

- Has duplicate Feature #9276: Log Time on an issue assigned to other added

#40 - 2018-05-05 23:32 - Marius BĂLTEANU

- Related to deleted (Feature #6486: Log time for other users)

#41 - 2018-05-05 23:32 - Marius BĂLTEANU

- Has duplicate Feature #6486: Log time for other users added

#42 - 2018-05-06 15:10 - Go MAEDA

Marius, thank you for your great work. This is one of the long-awaited features.

The patch 0001-Allow-the-current-user-to-log-time-for-other-users.patch works almost fine, however, I found only one small issue. Users who don't

have "Log spent time" permission should not be able to access TimelogController#new page, however, they can access the page via "+" button if they

have "Log time for other users" permission. They can fill the form but they will see 403 error after hitting "Create" button.

#43 - 2018-05-06 15:33 - Go MAEDA

- Target version set to Candidate for next major release

#44 - 2018-05-06 15:54 - Marius BĂLTEANU

- File 0001-Allow-the-current-user-to-log-time-for-other-users.patch added

Thanks for pointing this out. I've fixed the issue in the attached patch.

#45 - 2018-05-06 15:54 - Marius BĂLTEANU

- File deleted (0001-Allow-the-current-user-to-log-time-for-other-users.patch)

#46 - 2018-05-07 17:16 - Go MAEDA
- Target version changed from Candidate for next major release to 4.1.0

Now the patch series looks good. Setting target version to 4.1.0.

#47 - 2018-05-07 17:53 - Holger Just

I really like the idea of this feature and would love to have the ability to log time for other users in Redmine. Good job on polishing the patch and

making it ready for inclusion, Marius!

I still have some behavior-related comments about the latest patch by Marius from #3848-44:

If the current user doesn't have the permission to edit time entries for other users, I would rather see the creation / edit of a time entry rejected

rather than silently logged to the current user, e.g. with a validation error. The currentlt defined behavior could lead to unexpected data, esp.

when used via the API

TimelogHelper#user_collection_for_select_options should probably use collection = project.members.active.map(&:user) to ensure that locked

users don't show up in the list of users

The list of allowed users should be checked with a validation on the TimeEntry model too in order to prevent someone assigning hours to

arbitrary users.

In the TimelogController#create action, we will see an exception if somene (e.g. via the API) doesn't correctly provide params[:time_entries].

This case should be handled.

#48 - 2018-05-08 12:15 - Go MAEDA

- Assignee set to Marius BĂLTEANU

- Target version changed from 4.1.0 to Candidate for next major release

#49 - 2018-05-14 09:29 - Marius BĂLTEANU

Holger Just wrote:

I really like the idea of this feature and would love to have the ability to log time for other users in Redmine. Good job on polishing the patch and

making it ready for inclusion, Marius!

I still have some behavior-related comments about the latest patch by Marius from #3848-44:

If the current user doesn't have the permission to edit time entries for other users, I would rather see the creation / edit of a time entry

rejected rather than silently logged to the current user, e.g. with a validation error. The currentlt defined behavior could lead to unexpected

data, esp. when used via the API

TimelogHelper#user_collection_for_select_options should probably use collection = project.members.active.map(&:user) to ensure that

locked users don't show up in the list of users

The list of allowed users should be checked with a validation on the TimeEntry model too in order to prevent someone assigning hours to

arbitrary users.

In the TimelogController#create action, we will see an exception if somene (e.g. via the API) doesn't correctly provide

params[:time_entries]. This case should be handled.

 Thanks Holger for your feedback. I'll update my patch these days to integrate your feedback.

#50 - 2018-06-21 23:17 - Marius BĂLTEANU

- File 0001-Allow-the-current-user-to-log-time-for-other-users.patch added

- Assignee deleted (Marius BĂLTEANU)

I've reworked my patch in order to include the issues reported by Holger Just.

#51 - 2018-06-21 23:18 - Marius BĂLTEANU

- File deleted (0001-Allow-the-current-user-to-log-time-for-other-users.patch)

#52 - 2018-06-23 07:31 - Marius BĂLTEANU

- Target version changed from Candidate for next major release to 4.1.0

#53 - 2018-07-05 15:25 - Go MAEDA

- Assignee set to Jean-Philippe Lang

#54 - 2018-12-16 17:40 - Jean-Philippe Lang

- Subject changed from Allow the current user to record the time spent by another one. to Permission to log time for another user

- Status changed from New to Closed

- Resolution set to Fixed
Patch is committed, thanks for your work on this feature.

#55 - 2018-12-16 19:31 - Marius BĂLTEANU

- File fix_locales.diff added

- Status changed from Closed to Reopened

Jean-Philippe, please apply the attached patch in order to update the translation for error_not_allowed_to_log_time_for_other_users also for the

generated locales. I think that you first generated the locales and after that you have changed the en translation.

#56 - 2018-12-16 20:03 - Jean-Philippe Lang

- Status changed from Reopened to Closed

You're right, thanks!

#57 - 2018-12-17 19:14 - Marius BĂLTEANU

Oh, sorry, I've missed to update the translation for en-GB.yml in my previous patch (source:trunk/config/locales/en-GB.yml#L1263).

#58 - 2018-12-18 06:48 - Marius BĂLTEANU

- Status changed from Closed to Reopened

Please commit the below change:

vagrant@jessie:/vagrant/project/redmine$ git diff

diff --git a/config/locales/en-GB.yml b/config/locales/en-GB.yml

index 00db732..5cd0e14 100644

--- a/config/locales/en-GB.yml

+++ b/config/locales/en-GB.yml

@@ -1260,6 +1260,5 @@ en-GB:

   error_spent_on_future_date: Cannot log time on a future date

   setting_timelog_accept_future_dates: Accept time logs on future dates

   label_delete_link_to_subtask: Delete relation

-  error_not_allowed_to_log_time_for_other_users: Your role is not allowed to log time

-    for other users

+  error_not_allowed_to_log_time_for_other_users: You are not allowed to log time for other users

   permission_log_time_for_other_users: Log spent time for other users

#59 - 2019-01-20 08:41 - Jean-Philippe Lang

- Status changed from Reopened to Closed

Done.

#60 - 2019-10-28 14:24 - Go MAEDA

- Related to Patch #32196: Allow import time entries for other users added

#61 - 2020-01-12 22:52 - Marius BĂLTEANU

- Related to Defect #32774: Creating time tracking entry for other user through rest API fails with 403 added

#62 - 2020-02-06 13:47 - Go MAEDA

- Related to Defect #32959: Fix selected user on log time edit page when user has permissions to log time for another user added

#63 - 2020-02-08 22:02 - Marius BĂLTEANU

- Related to Defect #32973: Editing a time entry for a locked user changes the user to the current user added

#64 - 2020-03-08 13:59 - Go MAEDA

- Has duplicate Feature #3800: Editing time entries should show the person involved added

#65 - 2020-03-08 22:06 - Marius BĂLTEANU

- Has duplicate deleted (Feature #3800: Editing time entries should show the person involved)

#66 - 2020-03-08 22:06 - Marius BĂLTEANU
- Related to Feature #3800: Editing time entries should show the person involved added

#67 - 2022-02-22 14:35 - Meindert Oldenburger

Hello, thanks for the good work.

Is there a patch that I can apply on redmine 4.0.7? I can't upgrade because of redmine debian multiple instances solution we use.
